/*
 * Copyright (C) 2006 Terry Stenvold
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <stdio.h>
#include "pz.h"
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

static PzModule *module;
static TWindow *window;
static TWidget *wid;
static ttk_surface image[9];
static ttk_color bg, fg, tx;
static char file[10];
static int mine[4], 
	   comps[4], 
	   flop[10],
	   flops, 
	   msuit[2], 
	   csuit[2], 
	   fsuit[5],
	   csort[7],
	   msort[7],
	   sorts,
	   chips=150,
	   chips2=150,
	   cchips=150,
	   w,
	   h, 
	   bet=10, 
	   betset=10, 
	   aibet, 
	   cbet=10, 
	   dup=0;
static int cpair=0, cstra=0, mpair=0, mstra=0, cscore, mscore, won,be=0,dspchips=0, bet2=0, raised=0;


static char *nums[] = {
    " ", "2","3", "4", "5", "6","7", "8", "9", "10","J", "Q", "K", "A"
};

static void win_poker()
{

if(cscore>mscore)won=2;

else if(mscore>cscore)won=1; 

else if(mscore==cscore&&(mscore==8||mscore==4)){
	if (mstra>cstra){won=1;}
	else if (mstra<cstra){won=2;}
	else if (mstra==cstra){
			if ((comps[0]+comps[1])>(mine[0]+mine[1])){won=2;}
			else if ((comps[0]+comps[1])<(mine[0]+mine[1])){won=1;}}
}

else if(mscore==cscore&&(mscore==7||mscore==6||mscore==3||mscore==1||mscore==2)){
	if (mpair>cpair){won=1;}
	else if (mpair<cpair){won=2;}
        else if (mpair==cpair){
			if ((comps[0]+comps[1])>(mine[0]+mine[1])){won=2;}
			else if ((comps[0]+comps[1])<(mine[0]+mine[1])){won=1;}}
}
else won=3;
}

static void comp_bet()
{
aibet= random() %15;
int c2bet=cbet, c2chips=cchips;

if (cbet<betset){be=0;}
if (chips<=4){be=1; cbet=bet;}

     if (dspchips==1&&cscore>=5&&aibet>=5&&aibet<=15&&bet2==0){cbet=bet; bet2=1; }
else if (dspchips==1&&cscore>=3&&aibet>=8&&aibet<=15&&bet2==0){cbet=bet; bet2=1; }
else if (dspchips==1&&cscore>=1&&aibet>=14&&aibet<=15&&bet2==0){cbet=bet; bet2=1;}
else if (dspchips==1&&bet2==0){won=6; bet2=1;}

if (flops==0&&be==0&&dspchips==0){
 
 if ((betset-cbet)>10&&aibet>=13&&aibet<=15){cchips-=(betset-cbet); cbet=betset;}
 else if (comps[0]+comps[1]>=18&&aibet>=3&&aibet<=6){cchips-=(betset-cbet+5); cbet=betset+5; be=1;}
 else if (comps[0]+comps[1]>=18&&aibet==1){cchips-=(betset-cbet+10); cbet=betset+10; be=1;}
 else if (aibet>=1&&aibet<=7) {cchips-=(betset-cbet)+5; cbet=betset+5; be=1;}
 else {cchips-=(betset-cbet); cbet=betset;}

 if (aibet==7){cchips-=(betset-cbet+10); cbet=betset+10; be=1;}

 if (comps[0]+comps[1]<=12&&aibet==13){won=6; cbet=c2bet; cchips=c2chips;}
 //else if ((betset-cbet)>10&&cscore<3&&aibet>=14&&aibet<=15){won=6; cbet=c2bet;cchips=c2chips;}
 //else if ((betset-cbet)>25&&aibet>=9&&aibet<=13){won=6; cbet=c2bet;cchips=c2chips;}
}

else if (flops==1&&be==0&&dspchips==0){
 
 if ((betset-cbet)>10&&aibet>=13&&aibet<=15){cchips-=(betset-cbet); cbet=betset;}
 else if (cscore>2&&aibet>=3&&aibet<=12) {cchips-=(betset-cbet)+5; cbet=betset+5; be=1;}
 else if (cscore>4&&aibet>=3&&aibet<=12) {cchips-=(betset-cbet)+8; cbet=betset+8; be=1;}
 else if (aibet>=8&&aibet<=12) {cchips-=(betset-cbet)+5; cbet=betset+5; be=1;}
 else {cchips-=(betset-cbet); cbet=betset;}

 if (aibet==7){cchips-=(betset-cbet+5); cbet=betset+10; be=1;}

 if (comps[0]+comps[1]<=14&&aibet>=13&&aibet<=15){won=6; cbet=c2bet;cchips=c2chips;}
 else if ((betset-cbet)>10&&cscore<3&&aibet>=14&&aibet<=15){won=6; cbet=c2bet;cchips=c2chips;}
 else if ((betset-cbet)>30&&cscore<3&&aibet>=13&&aibet<=15){won=6; cbet=c2bet;cchips=c2chips;}
 else if ((betset-cbet)>25&&aibet>=9&&aibet<=13&&cscore<=2){won=6; cbet=c2bet;cchips=c2chips;}
 if (cscore==0){won=6; cbet=c2bet;cchips=c2chips;}
}

else if (flops==2&&be==0&&dspchips==0){

 if ((betset-cbet)>10&&aibet>=13&&aibet<=15){cchips-=(betset-cbet); cbet=betset;}
 if (cscore>2&&aibet>=3&&aibet<=12) {cchips-=(betset-cbet)+5; cbet=betset+5; be=1;}
 else if (cscore>5&&aibet>=3&&aibet<=12) {cchips-=(betset-cbet)+15; cbet=betset+15;be=1;}
 else {cchips-=(betset-cbet); cbet=betset;}

 if (aibet==7){cchips-=(betset-cbet+10); cbet=betset+10; be=1;}

 if (comps[0]+comps[1]<=12&&aibet>=10&&aibet<=15){won=6; cbet=c2bet;cchips=c2chips;} 
 if ((betset-cbet)>25&&aibet>=9&&aibet<=13&&cscore<=2){won=6; cbet=c2bet;cchips=c2chips;}
}

else if (flops==3&&be==0&&dspchips==0){

 if (cscore>=3&&aibet>=8&&aibet<=12){cchips-=(betset-cbet+5); cbet=betset+5; be=1;}
 else if (cscore>=5&&aibet>=3&&aibet<=15){cchips-=(betset-cbet+15); cbet=betset+15; be=1;}
 else if (comps[0]+comps[1]>=18&&aibet==1){cchips-=(betset-cbet+10); cbet=betset+10; be=1;}
 else {cchips-=(betset-cbet); cbet=betset;}

 if (aibet>=7&&cscore>=2){cchips-=(betset-cbet+10); cbet=betset+10; be=1;}

 if (cscore<1&&aibet>=8&&aibet<=9){won=6; cbet=c2bet;cchips=c2chips;}
 else if ((betset-cbet)>25&&cscore<=2){won=6; cbet=c2bet;cchips=c2chips;}
}
raised=(cbet-betset);
if (cchips<=15){cchips=0; cbet=betset;}
if ((cbet-betset)>=chips){be=1; cbet=bet;}
wid->dirty++;
}

static void ai_sort() //sort array of comps + flops cards
{
 int i, x;

 for (i=0;i<=4;i++){csort[i]=flop[i];}

  csort[5]=comps[0];
  csort[6]=comps[1];	

  for (i=0;i<=6;i++){
	for (x=i+1;x<=6;x++){
	   if (csort[i] > csort[x])
		{
		sorts = csort[x];
		csort[x] = csort[i];
		csort[i] = sorts;
		}
	}}

}

static void mine_sort() //sort array of mine + flops cards
{
 int i, x;

 for (i=0;i<=4;i++){msort[i]=flop[i];}

  msort[5]=mine[0];
  msort[6]=mine[1];	

  for (i=0;i<=6;i++){
	for (x=i+1;x<=6;x++){
	   if (msort[i] > msort[x])
		{
		sorts = msort[x];
		msort[x] = msort[i];
		msort[i] = sorts;
		}
	}}

}

static void mine_check() //finds my best 5 card hand 
{
int i,c, pair=0, f2pair=0, hart=0, spad=0, clu=0,  diam=0, flush=0,  rflush=0, stra=0;


   mine_sort();

	for (i=0;i<=6;i++){ //checks pair, 2pair, 3kind, 4kind;
	 for (c=i+1;c<=6;c++){
	  if(msort[c]==msort[i]){pair++; mpair+=msort[i];}}}

	if (pair==3){
	 for (i=0;i<=6;i++){
	 	if (mpair==csort[i]){f2pair++;}}}


	for (c=1;c<=9;c++){
	 for (i=0;i<=2;i++){
		if(msort[i]==c){stra++; mstra=msort[i]; }
		if(msort[i+1]==c+1){stra++; }
		if(msort[i+2]==c+2){stra++; }
		if(msort[i+3]==c+3){stra++; }
		if(msort[i+4]==c+4){stra++; }
		if(stra==5){break;}
		else {stra=0;}
	}
		if(stra==5){break;}
}
	


  for (i=5;i<=9;i++){ //check cards same suit in flop
        if(flop[i]>=20&&flop[i]<=35)     {clu++;}
	else if(flop[i]>=40&&flop[i]<=55){spad++;}
	else if(flop[i]>=60&&flop[i]<=75){hart++;}
	else if(flop[i]>=80&&flop[i]<=95){diam++;}}

  if(clu>=3||spad>=3||hart>=3||diam>=3) //more than 3 give posibility for flush
	{
	for (i=2;i<=3;i++){
         if(mine[i]>=20&&mine[i]<=35){clu++;}
	 else if(mine[i]>=40&&mine[i]<=55){spad++;}
	 else if(mine[i]>=60&&mine[i]<=75){hart++;}
	 else if(mine[i]>=80&&mine[i]<=95){diam++;}}

   if (clu>=5||spad>=5||hart>=5||diam>=5){ //check for Flush
		flush=5; 
	for (i=0;i<=4;i++){ //checks for Royal Flush
         if(flop[i]==13){rflush++;}
	 else if(flop[i]==12){rflush++;}
	 else if(flop[i]==11){rflush++;}
	 else if(flop[i]==10){rflush++;}
	 else if(flop[i]==9){rflush++;}}
	 if(mine[0]>=9&&(mine[0]<=12||mine[1]>=9)&&mine[1]<=12){rflush++;}
	 else if (mine[0]==13||mine[1]==13){rflush++;}}
}

 if (rflush==5)			{mscore=9;}   
 else if (flush==5&&stra==5)	{mscore=8;}   
 else if (pair==6)		{mscore=7;}   
 else if (pair==4)		{mscore=6;}   
 else if (flush==5)		{mscore=5;}  
 else if (stra==5)		{mscore=4;}
 else if (pair==3)		{mscore=3;} 
 else if (pair==3&&f2pair==0)	{mscore=2;}
 else if (pair==2)		{mscore=2;}
 else if (pair==1)		{mscore=1;}
}


static void ai_check() //finds comps best 5 card hand 
{
int i,c, pair=0, f2pair=0, hart=0, spad=0, clu=0,  diam=0, flush=0,  rflush=0, stra=0;


   ai_sort();

	for (i=0;i<=6;i++){ //checks pair, 2pair, 3kind, 4kind;
	 for (c=i+1;c<=6;c++){
	  if(csort[c]==csort[i]){pair++; cpair+=csort[i];}}}

	if (pair==3){
	 for (i=0;i<=6;i++){
	 	if (cpair==csort[i]){f2pair++;}}}


	for (c=1;c<=7;c++){
	 for (i=0;i<=2;i++){
		if(csort[i]==c){stra++; cstra=csort[i];}
		if(csort[i+1]==c+1){stra++;}
		if(csort[i+2]==c+2){stra++;}
		if(csort[i+3]==c+3){stra++;}
		if(csort[i+4]==c+4){stra++;}
		if(stra==5){break;}
		else {stra=0;}
	}
	if(stra==5){break;}

}
	


  for (i=5;i<=9;i++){ //check cards same suit in flop
        if(flop[i]>=20&&flop[i]<=35)     {clu++;}
	else if(flop[i]>=40&&flop[i]<=55){spad++;}
	else if(flop[i]>=60&&flop[i]<=75){hart++;}
	else if(flop[i]>=80&&flop[i]<=95){diam++;}}

  if(clu>=3||spad>=3||hart>=3||diam>=3) //more than 3 give posibility for flush
	{
	for (i=2;i<=3;i++){
         if(comps[i]>=20&&comps[i]<=39){clu++;}
	 else if(comps[i]>=40&&comps[i]<=59){spad++;}
	 else if(comps[i]>=60&&comps[i]<=79){hart++;}
	 else if(comps[i]>=80&&comps[i]<=99){diam++;}}

   if (clu>=5||spad>=5||hart>=5||diam>=5){ //check for Flush
		flush=5; 
	for (i=0;i<=4;i++){ //checks for Royal Flush
         if(flop[i]==13){rflush++;}
	 else if(flop[i]==12){rflush++;}
	 else if(flop[i]==11){rflush++;}
	 else if(flop[i]==10){rflush++;}
	 else if(flop[i]==9){rflush++;}}
	 if(comps[0]>=9&&(comps[0]<=12||comps[1]>=9)&&comps[1]<=12){rflush++;}
	 else if (comps[0]==13||comps[1]==13){rflush++;}}
}

 if (rflush==5)			{cscore=9;}   
 else if (flush==5&&stra==5)	{cscore=8;}   
 else if (pair==6)		{cscore=7;}   
 else if (pair==4)		{cscore=6;}   
 else if (flush==5)		{cscore=5;}  
 else if (stra==5)		{cscore=4;}
 else if (pair==3)		{cscore=3;} 
 else if (pair==3&&f2pair==0)	{cscore=2;}
 else if (pair==2)		{cscore=2;}
 else if (pair==1)		{cscore=1;}
}


static void cards_check()
{
int i,c;

for (c=2;c<=3;c++){ //mine & comps vs flop for same suit same number
  	for (i=5;i<=9;i++){
 	 if (comps[c]==flop[i]||mine[c]==flop[i]) {dup++;}}
	 if (mine[c]==comps[c]||mine[2]==comps[3]||mine[3]==comps[2]) {dup++;}}

 if (comps[2]==comps[3]||mine[2]==mine[3]) {dup++;} //duplicates in hands

 for (i=5;i<=9;i++){ //duplicates in flop
 	 if (flop[i]==flop[4]&&i!=4) {dup++;}
	 else if (flop[i]==flop[5]&&i!=5) {dup++;}
	 else if (flop[i]==flop[6]&&i!=6) {dup++;}
	 else if (flop[i]==flop[7]&&i!=7) {dup++;}}

	
}

static void cards_pick()
{
int i, x;

srand(time(NULL)); 
do {

 dup=0;

 for (i=0;i<=1;i++){ //creates suits and cards
	mine[i] = random() %13 + 1 ;
	//mine[0] = 6;
	//mine[1] = 10;
	msuit[i] = random() %4 + 1;
	comps[i] = random() %13 + 1 ;
	//comps[0] = 13;
	//comps[1] = 2;
	csuit[i] = random() %4 + 1;}
	//csuit[0] = 1;
	//csuit[1] = 2;
	//msuit[0] = 2;
	//msuit[1] = 2;}

 for (i=0;i<=4;i++) { //creates suits and cards for flop
	flop[i] = random() %13 + 1; 
	//flop[0] = 13;
	//flop[1] = 7;
	//flop[2] = 8;
	///flop[3] = 3;
	//flop[4] = 10;
	fsuit[i] = random() %4 + 1;}
	//fsuit[0] = 2;
	//fsuit[1] = 2;
	//fsuit[2] = 2;
	//fsuit[3] = 1;
	//fsuit[4] = 1;}

 x=0;
	
 for (i=2;i<=3;i++) { //gives cards values according to suits and cardnumber
	mine[i] = mine[x] + (msuit[x] * 20)+1;
	comps[i] = comps[x] + (csuit[x] * 20)+1;
	x++;}
 x=0;

 for (i=5;i<=9;i++) { //gives flops values
	flop[i] = flop[x] + (fsuit[x] * 20)+1;
	x++;}


	cards_check(); //checks cards to see if any identical or more than 4 of one number.

}while (dup!=0);
	ai_check();
	mine_check();
	wid->dirty++;
}

static void reset_chips()
{
chips=150; cchips=150;
}

static void reset_poker()
{
chips-=10; cchips-=10;
bet=10; betset=10;
cbet=10; flops = -1;
cstra=0; cpair=0;
mstra=0; mpair=0;
cscore=0; mscore=0;
won=0;
bet2=0;
dspchips=0;
}


static void draw_poker_table (TWidget *wid, ttk_surface srf) 
{
   int deck, bpp;
    w =ttk_screen->w; h =ttk_screen->h;
	bpp =ttk_screen->bpp;    
	bg = ttk_makecol(12,126,21); 
	fg = ttk_makecol(BLACK);
	tx = fg;
	ttk_fillrect (srf, 0, 0, wid->win->w, wid->win->h, bg);

	    //ttk_window_set_title(wid, bet);
if (w>=200){
for (deck=0;deck<=3;deck++){ 	 
	ttk_blit_image (image[6], srf, ttk_screen->w/1.25+(deck*2), h/8-(deck));
}// deck of cards

for (deck=0;deck<=4;deck++){ 	 	

 	if (fsuit[deck] == 3 || fsuit[deck] == 4) {fg=ttk_makecol(255,0,0);}
	else {fg=ttk_makecol(BLACK);}

 	if (flops == 1 && deck <=2) {ttk_blit_image (image[fsuit[deck]], srf, ttk_screen->w-w+20 +(deck*30), h/3);}
 	 else if (flops == 2&& deck<=3) {ttk_blit_image (image[fsuit[deck]], srf, ttk_screen->w-w+20 +(deck*30), h/3);}
	 else if (flops == 3&& deck<=4) {ttk_blit_image (image[fsuit[deck]], srf, ttk_screen->w-w+20 +(deck*30), h/3);}
	 else if (flops == 4) {ttk_blit_image (image[fsuit[deck]], srf, ttk_screen->w-w+20 +(deck*30), h/3);}
	 else {ttk_blit_image (image[6], srf, ttk_screen->w-w+20 +(deck*30), h/3);}


	
if (flops == 1 && deck <=2){	  
	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[flop[deck]])) / 2-(w/2)+30 +(deck*30), h/2.7 ,fg, nums[flop[deck]]);}


else if (flops == 2&& deck<=3){ 
	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[flop[deck]])) / 2-(w/2)+30 +(deck*30), h/2.7 ,fg, nums[flop[deck]]);}

else if (flops == 3&& deck<=4){ 
	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[flop[deck]])) / 2-(w/2)+30 +(deck*30), h/2.7 ,fg, nums[flop[deck]]);}

else if (flops == 4){ 
	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[flop[deck]])) / 2-(w/2)+30 +(deck*30), h/2.7 ,fg, nums[flop[deck]]);}

} //Flop 4 cards

for (deck=0;deck<=1;deck++){ 		
 	if (msuit[deck] == 3 || msuit[deck] == 4) {fg=ttk_makecol(255,0,0);}
	 else {fg=ttk_makecol(BLACK);}


	ttk_blit_image (image[msuit[deck]], srf, ttk_screen->w/2-30 +(deck*30), h/1.6);

	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[mine[deck]])) / 2-15 +(deck*30), h/1.5 ,fg, nums[mine[deck]]);
} //Your Hand 2 cards Plus Card Number and Suit

for (deck=0;deck<=1;deck++){ 	

	if (csuit[deck] == 3 || csuit[deck] == 4) {fg=ttk_makecol(255,0,0);}
	else {fg=ttk_makecol(BLACK);} 

 if (flops==4) {ttk_blit_image (image[csuit[deck]], srf, ttk_screen->w-w+20 +(deck*30), 5);}
 else  {ttk_blit_image (image[6], srf, ttk_screen->w-w+20 +(deck*30), 5);}


if (flops==4){ttk_text(srf, ttk_menufont, ttk_screen->w-w+27+(deck*30), 12 ,fg, nums[comps[deck]]);}}//Comp Hand 2 cards

	
sprintf(file, " Bets ");
ttk_text(srf, ttk_menufont, w/1.5, h/1.5 ,tx, file);//Bet
sprintf(file, " %dK ", bet);
ttk_text(srf, ttk_menufont, w/1.5, h/1.3 ,tx, file);//Bet
sprintf(file, " %dK ", cbet);
ttk_text(srf, ttk_menufont, w/1.2, h/1.3 ,tx, file);//Comp Bet


if((cchips<=0||chips<=0)&&(flops>=4||won==5||won==6)){
	reset_chips();
	sprintf(file, "GameOver");
	ttk_text(srf, ttk_menufont, w/1.5, h/1.7 ,tx, file);}//you gameover screen
else if(won==1&&flops>=4){
	chips+=betset+cbet;
	sprintf(file, "YOU WON");
	ttk_text(srf, ttk_menufont, w/1.5, h/1.7 ,tx, file);}//you won screen
else if(won==2&&flops>=4&&dspchips==1){
	reset_chips();
 	sprintf(file, "GameOver");
	ttk_text(srf, ttk_menufont, w/1.5, h/1.7 ,tx, file);}//you lost screen
else if(won==2&&flops>=4){
	cchips+=betset+cbet;
 	sprintf(file, "YOU LOST");
	ttk_text(srf, ttk_menufont, w/1.5, h/1.7 ,tx, file);}//you lost screen
else if (flops>=4){
	cchips+=cbet; chips+=betset;
 	sprintf(file, "Tie");
	ttk_text(srf, ttk_menufont, w/1.5, h/1.7 ,tx, file);}//you tie screen
else if (flops<=3&&won==4){
 	sprintf(file, "You Fold");
	ttk_text(srf, ttk_menufont, w/1.5, h/1.7 ,tx, file);}//you folded screen
else if (flops<=3&&won==6){
 	sprintf(file, "Tux Folds");
	ttk_text(srf, ttk_menufont, w/1.5, h/1.7 ,tx, file);}//tuxfolded screen
else if (be==1&&flops<=3){
 	sprintf(file, "Tux Raises ");
	ttk_text(srf, ttk_menufont, w/1.5, h/1.7 ,tx, file);}//tux raises screen
else if (dspchips==1&&flops<=3){
 	sprintf(file, "ALL IN");
	ttk_text(srf, ttk_menufont, w/1.5, h/1.7 ,tx, file);}//ALL IN screen

if (chips>=320) {chips=320;} 
	 else if (cchips>=320) {cchips=320;}


if (dspchips==0){
for (deck=0;deck<=(chips/10);deck++){ 	
sprintf(file, "7.gif");

if (deck>=1){	ttk_blit_image (image[7], srf, ttk_screen->w-w+5, h/1.4-(deck));}

if (deck>=2){	ttk_blit_image (image[7], srf, ttk_screen->w-w+20, h/1.4-(deck));}

if (deck>=7){	ttk_blit_image (image[7], srf, ttk_screen->w-w+37, (h/1.35-(deck))-1);}}//chips
sprintf(file, "%d", chips);
	ttk_text(srf, ttk_menufont, w/4.6, h/1.25 ,tx, file);//money
}

for (deck=0;deck<=(cchips/10);deck++){
	
sprintf(file, "8.gif");

if (deck>=1){	ttk_blit_image (image[8], srf, ttk_screen->w/2.25+5, 30-(deck));}

if (deck>=2){	ttk_blit_image (image[8], srf, ttk_screen->w/2.25+20, 30-(deck));}

if (deck>=7){	ttk_blit_image (image[8], srf, ttk_screen->w/2.25+40, (30-(deck))-1);}}//comp chips
sprintf(file, "%d", cchips);
	ttk_text(srf, ttk_menufont, w/1.6, h/4.6 ,tx, file);//money
}



else {
for (deck=0;deck<=3;deck++){ 	 
	sprintf(file, "%ds.gif", 6);

	ttk_blit_image (image[6], srf, ttk_screen->w/1.25+(deck*2), 5-(deck));
}// deck of cards

for (deck=0;deck<=4;deck++){ 	 	

 	if (fsuit[deck] == 3 || fsuit[deck] == 4) {
	 	fg=ttk_makecol(255,0,0);
		if (bpp<16){fg=ttk_makecol(DKGREY);}}
	else {fg=ttk_makecol(BLACK);}

 	if (flops == 1 && deck <=2) {ttk_blit_image (image[fsuit[deck]], srf, 10 +(deck*23), h/3.2);}
 	 else if (flops == 2&& deck<=3) {ttk_blit_image (image[fsuit[deck]], srf, 10 +(deck*23), h/3.2);}
	 else if (flops == 3&& deck<=4) {ttk_blit_image (image[fsuit[deck]], srf, 10 +(deck*23), h/3.2);}
	 else if (flops == 4) {ttk_blit_image (image[fsuit[deck]], srf, 10 +(deck*23), h/3.2);}
	 else {ttk_blit_image (image[6], srf, 10 +(deck*23), h/3.2);}

	
if (flops == 1 && deck <=2){	  
	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[flop[deck]])) / 2-(w/2.65)+(deck*23), h/3 ,fg, nums[flop[deck]]);}


else if (flops == 2&& deck<=3){ 
	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[flop[deck]])) / 2-(w/2.65)+(deck*23), h/3 ,fg, nums[flop[deck]]);}

else if (flops == 3&& deck<=4){ 
	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[flop[deck]])) / 2-(w/2.65)+(deck*23), h/3 ,fg, nums[flop[deck]]);}

else if (flops == 4){ 
	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[flop[deck]])) / 2-(w/2.65)+(deck*23), h/3 ,fg, nums[flop[deck]]);}

} //Flop 4 cards

for (deck=0;deck<=1;deck++){ 		
 	if ((msuit[deck] == 3 || msuit[deck] == 4))  {
	 	fg=ttk_makecol(255,0,0);
		if (bpp<16){fg=ttk_makecol(DKGREY);}}
	 else {fg=ttk_makecol(BLACK);}

	ttk_blit_image (image[msuit[deck]], srf, ttk_screen->w/2-25 +(deck*23), h/1.7);

	ttk_text(srf, ttk_menufont, (ttk_screen->w - ttk_text_width(ttk_menufont, nums[mine[deck]])) / 2-14 +(deck*23), h/1.6 ,fg, nums[mine[deck]]);
} //Your Hand 2 cards Plus Card Number and Suit

for (deck=0;deck<=1;deck++){ 	

	if (csuit[deck] == 3 || csuit[deck] == 4) {
	 	fg=ttk_makecol(255,0,0);
		if (bpp<16){fg=ttk_makecol(DKGREY);}}
	else {fg=ttk_makecol(BLACK);} 

 if (flops==4) {ttk_blit_image (image[csuit[deck]], srf, ttk_screen->w-w+20 +(deck*23), 3);}
 else  {ttk_blit_image (image[6], srf, ttk_screen->w-w+20 +(deck*23), 3);}

	
if (flops==4){ttk_text(srf, ttk_menufont, ttk_screen->w-w+23+(deck*23), 8 ,fg, nums[comps[deck]]);}}//Comp Hand 2 cards


sprintf(file, " Bets ");
ttk_text(srf, ttk_menufont, w/1.6, h/1.58 ,tx, file);//Bet
sprintf(file, " %dK ", bet);
ttk_text(srf, ttk_menufont, w/1.6, h/1.4 ,tx, file);//Bet
sprintf(file, " %dK ", cbet);
ttk_text(srf, ttk_menufont, w/1.3, h/1.4 ,tx, file);//Comp Bet


if((cchips<=0||chips<=0)&&(flops>=4||won==5||won==6)){
	reset_chips();
	sprintf(file, "GameOver");
	ttk_text(srf, ttk_menufont, w/1.6, h/1.8 ,tx, file);}//you gameover screen
else if(won==1&&flops>=4){
	chips+=betset+cbet;
	sprintf(file, "YOU WON");
	ttk_text(srf, ttk_menufont, w/1.6, h/1.8 ,tx, file);}//you won screen
else if(won==2&&flops>=4&&dspchips==1){
	reset_chips();
 	sprintf(file, "GameOver");
	ttk_text(srf, ttk_menufont, w/1.6, h/1.8 ,tx, file);}//you lost screen
else if(won==2&&flops>=4){
	cchips+=betset+cbet;
 	sprintf(file, "Tux WON");
	ttk_text(srf, ttk_menufont, w/1.6, h/1.8 ,tx, file);}//you lost screen
else if (flops>=4&&won==3){
	cchips+=cbet; chips+=betset;
 	sprintf(file, "Tie");
	ttk_text(srf, ttk_menufont, w/1.6, h/1.8 ,tx, file);}//you tie screen
else if (flops<=3&&won==4){
 	sprintf(file, "You Fold");
	ttk_text(srf, ttk_menufont, w/1.6, h/1.8 ,tx, file);}//you folded screen
else if (flops<=3&&won==6){
 	sprintf(file, "Tux Folds");
	ttk_text(srf, ttk_menufont, w/1.6, h/1.8 ,tx, file);}//tuxfolded screen
else if (be==1&&flops<=3){
 	sprintf(file, "Tux Raises");
	ttk_text(srf, ttk_menufont, w/1.6, h/1.8 ,tx, file);}//tux raises screen
else if (dspchips==1&&flops<=3){
 	sprintf(file, "ALL IN");
	ttk_text(srf, ttk_menufont, w/1.6, h/1.8 ,tx, file);}//ALL IN screen


if (chips>=320) {chips=320;} 
	 else if (cchips>=320) {cchips=320;}


if (dspchips==0){
for (deck=0;deck<=(chips/10);deck++){ 	
sprintf(file, "7s.gif");

if (deck>=1){	ttk_blit_image (image[7], srf, ttk_screen->w-w+5, h/1.4-(deck));}

if (deck>=2){	ttk_blit_image (image[7], srf, ttk_screen->w-w+20, h/1.4-(deck));}

if (deck>=7){	ttk_blit_image (image[7], srf, ttk_screen->w-w+37, (h/1.4-(deck))-1);}}//chips

sprintf(file, "%d", chips);
	ttk_text(srf, ttk_menufont, w/4.6, h/1.35 ,tx, file);//money

}

for (deck=0;deck<=(cchips/10);deck++){
	
if (deck>=1){	ttk_blit_image (image[8], srf, ttk_screen->w/2.25+5, 20-(deck));}

if (deck>=2){	ttk_blit_image (image[8], srf, ttk_screen->w/2.25+20, 20-(deck));}

if (deck>=7){	ttk_blit_image (image[8], srf, ttk_screen->w/2.25+35, (20-(deck))-1);}}//comp chips
sprintf(file, "%d", cchips);
	ttk_text(srf, ttk_menufont, w/1.6, h/5 ,tx, file);//comp money
}

}

static int event_poker (PzEvent *e) 
{

int ret = TTK_EV_CLICK;

switch(e->type) {

	case PZ_EVENT_SCROLL: //scroll function
	  TTK_SCROLLMOD( e->arg, 10);
		if( e->arg > 0){
			if (flops<=3&&bet<chips2&&dspchips!=1)
			{bet++;
			chips--;
			if (bet==chips2){chips=0;}
			wid->dirty++;}
			if (cbet>chips2){chips=0; betset=cbet;  wid->dirty++;}
			break;}

		else {if (flops<=3 && bet>betset&&dspchips!=1)
			{bet--; chips++;
			wid->dirty++;}
			break;}

	case PZ_EVENT_BUTTON_DOWN:
		switch (e->arg) {
		case PZ_BUTTON_ACTION:
			if (won==5) {reset_poker(); cards_pick(); reset_chips(); wid->dirty++;}
		        else if (chips<0||cchips<0) 
			{reset_poker(); cards_pick(); reset_chips(); wid->dirty++;}	
			else if (flops<=3&&won==4){
			won=0; cchips+=cbet+betset; reset_poker(); cards_pick();}
			else if (flops<=3&&won==6&&dspchips==1){
			won=0; chips+=cbet; reset_poker(); cards_pick();}
			else if (flops<=3&&won==6){
			won=0; chips+=cbet+betset; reset_poker(); cards_pick(); }
			else if (flops>=4) {reset_poker(); cards_pick(); }
			win_poker();
			betset=bet;
			comp_bet();
			if (cbet!=betset&&flops>=0){break;}
			else if (flops<=3&&won==4){won=0; reset_poker(); cards_pick();}
			else{flops++; be=0;}
			chips2=chips;
			wid->dirty++;
			break;

		case PZ_BUTTON_MENU:
			if (chips==0&&flops<=3){won=5; wid->dirty++;}
			else if (flops<=3) {won=4; wid->dirty++;}
			break;

		case PZ_BUTTON_NEXT:
			if (flops<=3&&bet<chips2&&dspchips!=1){
   			dspchips=1;
			bet+=chips;
			wid->dirty++;}
			break;

		case PZ_BUTTON_PLAY :
			reset_poker();
			reset_chips();
			cards_pick();
			flops=0;
			wid->dirty++;
			break;

		case PZ_BUTTON_HOLD :
			reset_poker();
			reset_chips();
			cards_pick();
			pz_close_window(e->wid->win);
			break;

		default:
			ret = TTK_EV_UNUSED;
		}
		break;

	case PZ_EVENT_TIMER:
		break;

	default:
		ret = TTK_EV_UNUSED;
		break;

	}
	return ret;
}

static TWindow *new_poker() 
{
    flops=0;
    window = pz_new_window ("PodPoker", PZ_WINDOW_NORMAL);
    wid = pz_add_widget(window, draw_poker_table, event_poker);
    cards_pick();

    return pz_finish_window (window);
}

static void init_poker()
{
int i;

 w =ttk_screen->w;

    module = pz_register_module ("PodPoker", NULL);
    pz_menu_add_action ("/Extras/Games/PodPoker", new_poker);

if (w<200){
 for(i=1;i<=8;i++){
	sprintf(file, "%ds.gif", i);
	image[i]=ttk_load_image (pz_module_get_datapath (module, file));}}
else{
 for(i=1;i<=8;i++){
	sprintf(file, "%d.gif", i);
	image[i]=ttk_load_image (pz_module_get_datapath (module, file));}}
}

PZ_MOD_INIT(init_poker)
